package de.fhdw.wtf.common.ast;

import java.io.Serializable;

import de.fhdw.wtf.common.token.Token;

/**
 * This class is the interface for {@link SyntaxObject}. It is necessary for multiple inheritance.
 */
public interface SyntaxObjectInterface extends Serializable {
	
	/**
	 * Get the First-Token.
	 * 
	 * @return First-Token
	 */
	Token getFirstToken();
	
	/**
	 * Set the First-Token.
	 * 
	 * @param firstToken
	 *            First-Token
	 */
	void setFirstToken(Token firstToken);
	
	/**
	 * Get the Last-Token.
	 * 
	 * @return Last-Token
	 */
	Token getLastToken();
	
	/**
	 * Set the Last-Token.
	 * 
	 * @param lastToken
	 *            Last-Token
	 */
	void setLastToken(Token lastToken);
	
}
