package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.AttributeModifierFindable;
import de.fhdw.wtf.common.ast.AttributeModifierMutable;
import de.fhdw.wtf.common.ast.AttributeModifierPrior;
import de.fhdw.wtf.common.ast.AttributeModifierSymmetric;
import de.fhdw.wtf.common.ast.AttributeModifierTransient;

/**
 * Return-Visitor of {@link de.fhdw.wtf.common.ast.AttributeModifier}.
 * 
 * @param <X>
 *            Return-type.
 */
public interface AttributeModifierVisitorReturn<X> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param modFindable
	 *            {@link AttributeModifierFindable}
	 * @return X
	 */
	X handle(AttributeModifierFindable modFindable);
	
	/**
	 * Handle-Method.
	 * 
	 * @param modPrior
	 *            {@link AttributeModifierPrior}
	 * @return X
	 */
	X handle(AttributeModifierPrior modPrior);
	
	/**
	 * Handle-Method.
	 * 
	 * @param modTransient
	 *            {@link AttributeModifierTransient}
	 * @return X
	 */
	X handle(AttributeModifierTransient modTransient);
	
	/**
	 * Handle-Method.
	 * 
	 * @param modMutable
	 *            {@link AttributeModifierMutable}
	 * @return X
	 */
	X handle(AttributeModifierMutable modMutable);
	
	/**
	 * Handle-Method.
	 * 
	 * @param modSymmetric
	 *            {@link AttributeModifierSymmetric}
	 * @return X
	 */
	X handle(AttributeModifierSymmetric modSymmetric);
}
