package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.DatabaseIDNotSetState;
import de.fhdw.wtf.common.ast.DatabaseIDSetState;

/**
 * Return-Exception-Visitor for {@link de.fhdw.wtf.common.ast.DatabaseIDState}.
 * 
 * @param <X>
 *            ReturnType
 * @param <Y>
 *            ExceptionType
 */
public interface DatabaseIDStateVisitorReturnException<X, Y extends Exception> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param a
	 *            {@link DatabaseIDNotSetState}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(DatabaseIDNotSetState a) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param a
	 *            {@link DatabaseIDSetState}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(DatabaseIDSetState a) throws Y;
	
}
