package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.QualifiedName;
import de.fhdw.wtf.common.ast.UnqualifiedName;

/**
 * Return-Visitor for {@link de.fhdw.wtf.common.ast.Name}.
 * 
 * @param <X>
 *            ReturnType
 */
public interface NameReturnVisitor<X> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param qualifiedName
	 *            {@link QualifiedName}
	 * @return X
	 */
	X handle(QualifiedName qualifiedName);
	
	/**
	 * Handle-Method.
	 * 
	 * @param unqualifiedName
	 *            {@link UnqualifiedName}
	 * @return X
	 */
	X handle(UnqualifiedName unqualifiedName);
}
