package de.fhdw.wtf.common.exception.ast;

/**
 * Represents exceptions related to errors in the abstract syntax tree (AST).
 */
public class ASTException extends RuntimeException {
	
	/**
	 * Creates an ASTException from a message.
	 * 
	 * @param message
	 *            The exception message.
	 */
	public ASTException(final String message) {
		super(message);
	}
	
	/**
	 * Creates an ASTException from a message and a cause.
	 * 
	 * @param message
	 *            The exception message.
	 * @param cause
	 *            The underlying cause.
	 */
	public ASTException(final String message, final Throwable cause) {
		super(message, cause);
	}
	
}
