package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoCurlyBracketCloseException} will be thrown if a
 * {@link de.fhdw.wtf.common.token.symbols.CurlyBracketCloseToken} is expected, but an another Token was found.
 * 
 */
public final class NoCurlyBracketCloseException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 5427779833606074530L;
	
	/**
	 * Constructor of {@link NoCurlyBracketCloseException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoCurlyBracketCloseException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoCurlyBracketCloseException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoCurlyBracketCloseException}-Object.
	 */
	public static NoCurlyBracketCloseException create(final Token token) {
		return new NoCurlyBracketCloseException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_BRACERIGHT_EXCEPTION_MESSAGE);
	}
	
}
