package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoCurlyBracketOpenException} will be thrown if a
 * {@link de.fhdw.wtf.common.token.symbols.CurlyBracketOpenToken} is expected, but an another Token was found.
 * 
 */
public final class NoCurlyBracketOpenException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -3121542950082382635L;
	
	/**
	 * Constructor of {@link NoCurlyBracketOpenException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoCurlyBracketOpenException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoCurlyBracketOpenException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoCurlyBracketOpenException}-Object.
	 */
	public static NoCurlyBracketOpenException create(final Token token) {
		return new NoCurlyBracketOpenException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_BRACELEFT_EXCEPTION_MESSAGE);
	}
	
}
