package de.fhdw.wtf.common.stream;

/**
 * Interface for data input of {@link de.fhdw.wtf.dsl.scanner.common.Scanner} functions.
 * 
 */
public interface ScannerInputStream {
	
	/**
	 * Returns the next <code>char</code> from the stream.
	 * 
	 * @return next <code>char</code>
	 */
	char next();
	
	/**
	 * Tests if the Stream has at least one <code>char</code> to offer.
	 * 
	 * @return <code>true</code> if there are 1 or more <code>char</code> left in the stream <br>
	 *         <code>false</code> if stream is empty.
	 */
	boolean hasNext();
	
}
