package de.fhdw.wtf.common.stream;

import java.util.ArrayList;
import java.util.List;

/**
 * ScannerInput that relies on a String as sorted source of characters.
 * 
 */
public class SimpleScannerInput implements ScannerInputStream {
	
	/**
	 * Splitted list of characters showing the stream.
	 */
	private final List<Character> data = new ArrayList<>();
	
	/**
	 * Constructor using a single String as input source.
	 * 
	 * @param input
	 *            characters in this stream
	 */
	public SimpleScannerInput(final String input) {
		for (int i = 0; i < input.length(); i++) {
			this.data.add(input.charAt(i));
		}
	}
	
	@Override
	public char next() {
		final char next = this.data.get(0);
		this.data.remove(0);
		return next;
	}
	
	@Override
	public boolean hasNext() {
		return !this.data.isEmpty();
	}
	
}
