package de.fhdw.wtf.walker.tasks;

import de.fhdw.wtf.common.ast.Attribute;
import de.fhdw.wtf.common.ast.Constructor;
import de.fhdw.wtf.common.ast.ConstructorOrOperation;
import de.fhdw.wtf.common.ast.Group;
import de.fhdw.wtf.common.ast.Model;
import de.fhdw.wtf.common.ast.Operation;
import de.fhdw.wtf.common.ast.type.ClassType;
import de.fhdw.wtf.common.ast.visitor.ConstructorOrOperationExceptionVisitor;
import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.walker.walker.SimpleWalkerTask;

public class InheritanceOfThrownExceptionsCheck extends SimpleWalkerTask {
	
	public InheritanceOfThrownExceptionsCheck(final Model m, final TaskExecutor taskmanager) {
		super(m, taskmanager);
		// Auto-generated constructor stub
	}
	
	@Override
	public void handleClass(final ClassType c) throws TaskException {
		// Auto-generated method stub
		
	}
	
	@Override
	public void handleGroup(final Group g) throws TaskException {
		// Auto-generated method stub
		
	}
	
	@Override
	public void handleAttribute(final Attribute a, final ClassType owner) throws TaskException {
		// Auto-generated method stub
		
	}
	
	@Override
	public void handleConstructorOrOperation(final ConstructorOrOperation coo, final ClassType owner)
			throws TaskException {
		coo.accept(new ConstructorOrOperationExceptionVisitor<TaskException>() {
			
			@Override
			public void handleOperation(final Operation operation) throws TaskException {
				final java.util.Iterator<Operation> itr = operation.getOverridingOperations().iterator();
				while (itr.hasNext()) {
					final Operation op = itr.next();
					if (!op.getReturnType().isMoreOrEqualSpecialThan(operation.getReturnType())) {
						throw new TaskException("Wrong Inheritance in Thrown Exceptions! ");
					} else {
						// do nothing;
					}
				}
			}
			
			@Override
			public void handleConstructor(final Constructor constructor) throws TaskException {
				// Nothing to do here
				
			}
		});
		
	}
	
	@Override
	public void finalizeTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void beginTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
}
